Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hsqldb.jdbc
Class jdbcBlob

    java.lang.Object
      org.hsqldb.jdbc.jdbcBlob

All Implemented Interfaces:
  java.sql.Blob

    public class jdbcBlob

extends java.lang.Object
implements java.sql.Blob

The representation (mapping) in the JavaTM programming language of an SQL BLOB value.

Provides methods for getting the length of an SQL BLOB (Binary Large Object) value, for materializing a BLOB value on the client, and for determining the position of an octet sequence (byte pattern) within a BLOB value.

### HSQLDB-Specific Information:

Including 1.8.x, the HSQLDB driver does not implement Blob using an SQL locator(BLOB). That is, an HSQLDB Blob object does not contain a logical pointer to SQL BLOB data; rather it directly contains a representation of the data (a byte array). As a result, an HSQLDB Blob object is itself valid beyond the duration of the transaction in which is was created, although it does not necessarily represent a corresponding value on the database.

Currently, the interface methods for updating a BLOB value are unsupported. However, the truncate method is supported for local use.

Since:
  JDK 1.2, HSQLDB 1.7.2
Author:
  james house jhouse@part.net, boucherb@users

Constructor Summary
`jdbcBlob(byte[] data)` Constructs a new jdbcBlob instance wrapping the given octet sequence.

Method Summary
`java.io.InputStream` | `getBinaryStream()` Retrieves the `BLOB` value designated by this `Blob` instance as a stream.
`byte[]` | `getBytes(long pos, int length)` Retrieves all or part of the `BLOB` value that this `Blob` object represents, as an array of bytes.
`long` | `length()` Returns the number of bytes in the `BLOB` value designated by this `Blob` object.
`long` | `position(java.sql.Blob pattern, long start)` Retrieves the byte position in the `BLOB` value designated by this `Blob` object at which `pattern` begins.
`long` | `position(byte[] pattern, long start)` Retrieves the byte position at which the specified byte array `pattern` begins within the `BLOB` value that this `Blob` object represents.
`java.io.OutputStream` | `setBinaryStream(long pos)` Retrieves a stream that can be used to write to the `BLOB` value that this `Blob` object represents.
`int` | `setBytes(long pos, byte[] bytes)` Writes the given array of bytes to the `BLOB` value that this `Blob` object represents, starting at position `pos`, and returns the number of bytes written.
`int` | `setBytes(long pos, byte[] bytes, int offset, int len)` Writes all or part of the given `byte` array to the `BLOB` value that this `Blob` object represents and returns the number of bytes written.
`void` | `truncate(long len)` Truncates the `BLOB` value that this `Blob` object represents to be `len` bytes in length.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.sql.Blob
`free, getBinaryStream`

Constructor Detail

### jdbcBlob

    public jdbcBlob(byte[] data)
             throws java.sql.SQLException

  Constructs a new jdbcBlob instance wrapping the given octet sequence.

  This constructor is used internally to retrieve result set values as Blob objects, yet it must be public to allow access from other packages. As such (in the interest of efficiency) this object maintains a reference to the given octet sequence rather than making a copy; special care should be taken by extenal clients never to use this constructor with a byte array object that may later be modified extenally.

  Parameters:
    `data` - the octet sequence representing the Blob value
  Throws:
    `java.sql.SQLException` - if the argument is null

Method Detail

### length

    public long length()
                throws java.sql.SQLException

  Returns the number of bytes in the `BLOB` value designated by this `Blob` object.

  Specified by:
    `length` in interface `java.sql.Blob`
  Returns:
    length of the `BLOB` in bytes
  Throws:
    `java.sql.SQLException` - if there is an error accessing the length of the `BLOB`
  Since:
    JDK 1.2, HSQLDB 1.7.2

### getBytes

    public byte[] getBytes(long pos,
                           int length)
                    throws java.sql.SQLException

  Retrieves all or part of the `BLOB` value that this `Blob` object represents, as an array of bytes. This `byte` array contains up to `length` consecutive bytes starting at position `pos`.

  ### HSQLDB-Specific Information:

  The official specification above is ambiguous in that it does not precisely indicate the policy to be observed when pos > this.length() - length. One policy would be to retrieve the octets from pos to this.length(). Another would be to throw an exception. HSQLDB observes the later policy.

  Specified by:
    `getBytes` in interface `java.sql.Blob`
  Parameters:
    `pos` - the ordinal position of the first byte in the `BLOB` value to be extracted; the first byte is at position 1
    `length` - the number of consecutive bytes to be copied
  Returns:
    a byte array containing up to `length` consecutive bytes from the `BLOB` value designated by this `Blob` object, starting with the byte at position `pos`
  Throws:
    `java.sql.SQLException` - if there is an error accessing the `BLOB` value
  Since:
    JDK 1.2, HSQLDB 1.7.2
  See Also:
    `setBytes(long, byte[])`

### getBinaryStream

    public java.io.InputStream getBinaryStream()
                                        throws java.sql.SQLException

  Retrieves the `BLOB` value designated by this `Blob` instance as a stream.

  Specified by:
    `getBinaryStream` in interface `java.sql.Blob`
  Returns:
    a stream containing the `BLOB` data
  Throws:
    `java.sql.SQLException` - if there is an error accessing the `BLOB` value
  Since:
    JDK 1.2, HSQLDB 1.7.2
  See Also:
    `setBinaryStream(long)`

### position

    public long position(byte[] pattern,
                         long start)
                  throws java.sql.SQLException

  Retrieves the byte position at which the specified byte array `pattern` begins within the `BLOB` value that this `Blob` object represents. The search for `pattern` begins at position `start`.

  Specified by:
    `position` in interface `java.sql.Blob`
  Parameters:
    `pattern` - the byte array for which to search
    `start` - the position at which to begin searching; the first position is 1
  Returns:
    the position at which the pattern appears, else -1
  Throws:
    `java.sql.SQLException` - if there is an error accessing the `BLOB`
  Since:
    JDK 1.2, HSQLDB 1.7.2

### position

    public long position(java.sql.Blob pattern,
                         long start)
                  throws java.sql.SQLException

  Retrieves the byte position in the `BLOB` value designated by this `Blob` object at which `pattern` begins. The search begins at position `start`.

  Specified by:
    `position` in interface `java.sql.Blob`
  Parameters:
    `pattern` - the `Blob` object designating the `BLOB` value for which to search
    `start` - the position in the `BLOB` value at which to begin searching; the first position is 1
  Returns:
    the position at which the pattern begins, else -1
  Throws:
    `java.sql.SQLException` - if there is an error accessing the `BLOB` value
  Since:
    JDK 1.2, HSQLDB 1.7.2

### setBytes

    public int setBytes(long pos,
                        byte[] bytes)
                 throws java.sql.SQLException

  Writes the given array of bytes to the `BLOB` value that this `Blob` object represents, starting at position `pos`, and returns the number of bytes written.

  ### HSQLDB-Specific Information:

  HSLQDB 1.7.2 does not support this feature.

  Calling this method always throws an `SQLException`.

  Specified by:
    `setBytes` in interface `java.sql.Blob`
  Parameters:
    `pos` - the position in the `BLOB` object at which to start writing
    `bytes` - the array of bytes to be written to the `BLOB` value that this `Blob` object represents
  Returns:
    the number of bytes written
  Throws:
    `java.sql.SQLException` - if there is an error accessing the `BLOB` value
  Since:
    JDK 1.4, HSQLDB 1.7.2
  See Also:
    `getBytes(long, int)`

### setBytes

    public int setBytes(long pos,
                        byte[] bytes,
                        int offset,
                        int len)
                 throws java.sql.SQLException

  Writes all or part of the given `byte` array to the `BLOB` value that this `Blob` object represents and returns the number of bytes written. Writing starts at position `pos` in the `BLOB` value; `len` bytes from the given byte array are written.

  ### HSQLDB-Specific Information:

  HSLQDB 1.7.2 does not support this feature.

  Calling this method always throws an `SQLException`.

  Specified by:
    `setBytes` in interface `java.sql.Blob`
  Parameters:
    `pos` - the position in the `BLOB` object at which to start writing
    `bytes` - the array of bytes to be written to this `BLOB` object
    `offset` - the offset into the array `bytes` at which to start reading the bytes to be set
    `len` - the number of bytes to be written to the `BLOB` value from the array of bytes `bytes`
  Returns:
    the number of bytes written
  Throws:
    `java.sql.SQLException` - if there is an error accessing the `BLOB` value
  Since:
    JDK 1.4, HSQLDB 1.7.2
  See Also:
    `getBytes(long, int)`

### setBinaryStream

    public java.io.OutputStream setBinaryStream(long pos)
                                         throws java.sql.SQLException

  Retrieves a stream that can be used to write to the `BLOB` value that this `Blob` object represents. The stream begins at position `pos`.

  ### HSQLDB-Specific Information:

  HSQLDB 1.7.2 does not support this feature.

  Calling this method always throws an `SQLException`.

  Specified by:
    `setBinaryStream` in interface `java.sql.Blob`
  Parameters:
    `pos` - the position in the `BLOB` value at which to start writing
  Returns:
    a `java.io.OutputStream` object to which data can be written
  Throws:
    `java.sql.SQLException` - if there is an error accessing the `BLOB` value
  Since:
    JDK 1.4, HSQLDB 1.7.2
  See Also:
    `getBinaryStream()`

### truncate

    public void truncate(long len)
                  throws java.sql.SQLException

  Truncates the `BLOB` value that this `Blob` object represents to be `len` bytes in length.

  ### HSQLDB-Specific Information:

  This operation affects only the client-side value; it has no effect upon the value as it is stored in the database.

  Specified by:
    `truncate` in interface `java.sql.Blob`
  Parameters:
    `len` - the length, in bytes, to which the `BLOB` value that this `Blob` object represents should be truncated
  Throws:
    `java.sql.SQLException` - if there is an error accessing the `BLOB` value
  Since:
    JDK 1.4, HSQLDB 1.7.2

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001 - 2005 HSQL Development Group. All Rights Reserved.